﻿namespace NotAWif.Security
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web.Security;

    public class SmallRoles : RoleProvider
    {
        private static readonly Dictionary<String, String[]> _roles = new Dictionary<String, String[]>
                                                                    {
                                                                        {"Admin", new []{"Administrator"}},
                                                                        {"Rory", new[]{"RandomRole","Administrator"}},
                                                                        {"User", new[]{"RandomRole"}}
    };

        public override bool IsUserInRole(string username, string roleName)
        {
            if (_roles.ContainsKey(username) == false)
            {
                return false;
            }

            String[] roles = _roles[username];

            return roles.Any(x => x == roleName);
        }

        public override string[] GetRolesForUser(string username)
        {
            if (_roles.ContainsKey(username) == false)
            {
                return null;
            }

            return _roles[username];
        }

        public override void CreateRole(string roleName)
        {
            throw new NotImplementedException();
        }

        public override bool DeleteRole(string roleName, bool throwOnPopulatedRole)
        {
            throw new NotImplementedException();
        }

        public override bool RoleExists(string roleName)
        {
            throw new NotImplementedException();
        }

        public override void AddUsersToRoles(string[] usernames, string[] roleNames)
        {
            throw new NotImplementedException();
        }

        public override void RemoveUsersFromRoles(string[] usernames, string[] roleNames)
        {
            throw new NotImplementedException();
        }

        public override string[] GetUsersInRole(string roleName)
        {
            throw new NotImplementedException();
        }

        public override string[] GetAllRoles()
        {
            throw new NotImplementedException();
        }

        public override string[] FindUsersInRole(string roleName, string usernameToMatch)
        {
            throw new NotImplementedException();
        }

        public override string ApplicationName
        {
            get
            {
                throw new NotImplementedException();
            }
            set
            {
                throw new NotImplementedException();
            }
        }
    }
}
